<?php
 class wpsg_statisticabstract { protected $shop; protected $db; public $sqlWhere = ''; protected $observeStatuscodes; public function __construct() { $this->shop = &$GLOBALS['wpsg_sc']; $this->db = &$GLOBALS['wpsg_db']; $this->observeStatuscodes = $this->shop->get_option('wpsg_mod_statistics_status'); $this->setSqlWhere(); } public function getCustomerCount() { $data = $this->db->fetchOne("SELECT COUNT(*) FROM `".WPSG_TBL_KU."`"); if ($data !== false) return $data; return 0; } public function getProductCount() { $data = $this->db->fetchOne("SELECT COUNT(*) FROM `".WPSG_TBL_PRODUCTS."` WHERE `deleted` != '1'"); if ($data !== false) return $data; return 0; } public function getOrderCount() { $data = $this->db->fetchOne("SELECT COUNT(*) FROM `".WPSG_TBL_ORDER."` WHERE `status` IN(".$this->observeStatuscodes.")"); if ($data !== false) return $data; return 0; } public function getDailyTurnover($timestamp = 0) { if ($timestamp == 0) { $timestamp = time(); } $data = $this->db->fetchOne("
				SELECT 
					SUM(`price_gesamt`) 
			  	FROM 
			  		`".WPSG_TBL_ORDER."` 
			  	WHERE 
			  		".$this->getSqlWhere('validOrder')." AND 
			  		YEAR( `cdate` ) = '".date('Y', $timestamp)."' AND 
	  				MONTH ( `cdate` ) = '".date('m', $timestamp)."' AND 
	  				DAY (`cdate`) = '".date('d', $timestamp)."'
	  	"); if ($data !== false) return $data; return 0; } public function getTotalTurnover() { $data = $this->db->fetchOne("
				SELECT 
				 	SUM(`price_gesamt`) 
			  	FROM 
			  		`".WPSG_TBL_ORDER."` 
			 	WHERE 
			  		".$this->getSqlWhere('validOrder') ); if ($data !== false) return $data; return 0; } public function setSqlWhere() { $this->sqlWhere['validOrder'] = "`cdate` != '0000-00-00 00:00:00' AND 
													  		`type_payment` != '' AND 
													  		`type_payment` IS NOT NULL AND 
													  		`status` IN(".$this->observeStatuscodes.")"; } public function getSqlWhere($key = '') { if (isset($this->sqlWhere[$key])) { return $this->sqlWhere[$key]; } return ''; } public function getShopOrderYears() { $years = array_keys($this->db->fetchAssoc("  SELECT 
															YEAR( `cdate` ) AS orderyear 
													 FROM 
													 		`".WPSG_TBL_ORDER."` 
													 WHERE
													 		`cdate` != '0000-00-00 00:00:00' AND 
													  		`type_payment` != '' AND 
													  		`type_payment` IS NOT NULL AND 
													  		`status` IN(".$this->observeStatuscodes.") 
													 GROUP BY 
													  		orderyear
													 ORDER BY 
													  		orderyear DESC", "orderyear")); return $years; } public function getDaysofMonth($month, $year) { $time = mktime(0, 0, 0, $month, 1, $year); return date('t', $time); } } ?>