<?php
 require_once WPSG_PATH_MOD.'mod_statistics/wpsg_statisticabstract.php'; class wpsg_turnoverperhour extends wpsg_statisticabstract { public function setEmptyHours($day, &$arData) { $daytime = strtotime(date('d.m.Y 00:00:00', $day)); for ($i = 0; $i < 24; $i++) { if (!isset($arData[0]['records'][date('G', $daytime)])) { $arData[0]['records'][date('G', $daytime)] = array( 'orders' => '', 'total' => '0', 'hour' => date('G', $daytime), 'day' => date('d', $daytime), 'month' => date('m', $daytime), 'year' => date('Y', $daytime)); } $daytime += 3600; } } public function getAll($point = 0) { $day = time(); $arData[0]['records'] = $this->db->fetchAssoc("	SELECT 
															    COUNT(*) AS orders,
																SUM( `price_gesamt` ) AS total,
																HOUR( `cdate` ) AS hour, 
																'".date('d', $day)."' AS day, 
																'".date('m', $day)."' AS month, 
																'".date('Y', $day)."' AS year
														 FROM 
														  		`".WPSG_TBL_ORDER."`
														 WHERE 
														  		".$this->getSqlWhere('validOrder')."
														 GROUP BY 
														 		year, month, day, hour
														 ORDER BY 
														 		hour ASC
														 ", "hour"); $this->setEmptyHours($day, $arData); $arData['template'] = 'all'; $arData[0]['day'] = date('d', $day); $arData[0]['month'] = date('m', $day); $arData[0]['year'] = date('Y', $day); $arData[0]['label'] = __('Umsatz pro Stunde (Gesamt)', 'wpsg'); ksort($arData[0]['records']); return $arData; } public function getYear($point = 0, $params = array()) { if ($point == '0') { $year = date('Y'); } else if ($point == '-1') { $year = date('Y') - 1; } else { $year = $point; } $day = time(); $arData[0]['records'] = $this->db->fetchAssoc(" SELECT 
															COUNT(*) AS orders,
															SUM( `price_gesamt` ) AS total,
															HOUR( `cdate` ) AS hour, 
															'".date('d', $day)."' AS day, 
															'".date('m', $day)."' AS month, 
															'".date('Y', $day)."' AS year
													  	FROM 
													  		`".WPSG_TBL_ORDER."`
													  	WHERE 
													  		".$this->getSqlWhere('validOrder')." AND 
													  		YEAR( `cdate` ) = '".$year."'
													  	GROUP BY 
													  		hour
													  	ORDER BY 
													  		hour ASC
													   ", "hour"); $this->setEmptyHours($day, $arData); $arData['template'] = 'all'; $arData[0]['day'] = date('d', $day); $arData[0]['month'] = date('m', $day); $arData[0]['year'] = date('Y', $day); $arData[0]['label'] = __('Umsatz pro Stunde', 'wpsg').' '.$year; ksort($arData[0]['records']); if (isset($params['relatedpoint']) && is_numeric($params['relatedpoint'])) { $arRelatedData = $this->getYear($params['relatedpoint']); $arData[] = $arRelatedData[0]; } return $arData; } public function getQuarter($point = 0, $params = array()) { $arQuarter = array( '1' => array(1, 2, 3), '2' => array(4, 5, 6), '3' => array(7, 8, 9), '4' => array(10, 11, 12)); if ($point == '0') { $year = date('Y'); $month = date('n'); } else if ($point == '-1') { $year = date('Y'); $month = date('n'); foreach ($arQuarter as $index => $quarter) { if (in_array($month, $quarter)) { if (isset($actQuarter[$index - 1])) { $quarterFirstMonth = $arQuarter[$index - 1][0]; } else { $quarterFirstMonth = $arQuarter[count($arQuarter)][0]; $year--; } } } $month = $quarterFirstMonth; } foreach ($arQuarter as $index => $quarter) { if (in_array($month, $quarter)) { $actQuarter = $index; $lastMonth = $arQuarter[$index][count($arQuarter[$index]) - 1]; $daysLastMonth = wpsg_getDaysofMonth($lastMonth, $year); $dayLastMonthTS = mktime(0, 0, 0, $lastMonth, $daysLastMonth, $year); $firstMonth = array_shift($arQuarter[$index]); $dayFirstMonthTS = mktime(0, 0, 0, $firstMonth, 1, $year); } } $day = time(); $arData[0]['records'] = $this->db->fetchAssoc(" SELECT 
														    COUNT(*) AS orders,
															SUM( `price_gesamt` ) AS total,
															HOUR( `cdate` ) AS hour, 
															'".date('d', $day)."' AS day, 
															'".date('m', $day)."' AS month, 
															'".date('Y', $day)."' AS year
													  	FROM 
													  		`".WPSG_TBL_ORDER."`
													 	WHERE 
													  		".$this->getSqlWhere('validOrder')." AND 
													  		`cdate` >= '".date('Y-m-d H:i:s', $dayFirstMonthTS)."' AND 
													  		`cdate` <= '".date('Y-m-d H:i:s', $dayLastMonthTS)."'
													  	GROUP BY 
													  		hour
													  	ORDER BY 
													  		hour ASC
													  ", "hour"); $this->setEmptyHours($day, $arData); $arData['template'] = 'all'; $arData[0]['day'] = date('d', $day); $arData[0]['month'] = date('m', $day); $arData[0]['year'] = date('Y', $day); $arData[0]['label'] = $actQuarter.".".__('Quartal', 'wpsg').' '.$year; ksort($arData[0]['records']); if (isset($params['relatedpoint']) && is_numeric($params['relatedpoint'])) { $arRelatedData = $this->getQuarter($params['relatedpoint']); $arData[] = $arRelatedData[0]; } return $arData; } public function getMonth($point = 0, $params = array()) { if ($point == '0') { $year = date('Y'); $month = date('n'); } else if ($point == '-1') { $year = date('Y'); $month = date('n') - 1; if ($month == 0) { $month = 12; $year--; } } $day = time(); $arData[0]['records'] = $this->db->fetchAssoc(" SELECT 
														   COUNT(*) AS orders,
															SUM( `price_gesamt` ) AS total,
															HOUR( `cdate` ) AS hour, 
															'".date('d', $day)."' AS day, 
															'".date('m', $day)."' AS month, 
															'".date('Y', $day)."' AS year
													  	FROM 
													  		`".WPSG_TBL_ORDER."`
													  	WHERE 
													  		".$this->getSqlWhere('validOrder')." AND 
													  		YEAR( `cdate` ) = '".$year."' AND 
													  		MONTH ( `cdate` ) = '".$month."'
													  	GROUP BY 
													  		hour
													  	ORDER BY 
													  		hour ASC
													  ", "hour"); $this->setEmptyHours($day, $arData); $arData['template'] = 'all'; $arData[0]['day'] = date('d', $day); $arData[0]['month'] = date('m', $day); $arData[0]['year'] = date('Y', $day); $arData[0]['label'] = date_i18n('F', mktime(0, 0 , 0, $month, 1, $year)).' '.$year; ksort($arData[0]['records']); if (isset($params['relatedpoint']) && is_numeric($params['relatedpoint'])) { $arRelatedData = $this->getMonth($params['relatedpoint']); $arData[] = $arRelatedData[0]; } return $arData; } public function getWeek($point = 0, $params = array()) { $adjustment = 1; if ($point == '0') { $weekday = date("w", time()); $firstDayofWeek = time() - (($weekday - $adjustment)*86400); $lastDayofWeek = time() + ((6 + $adjustment - $weekday) * 86400); } else if ($point == '-1') { $time = time() - (6*86400); $weekday = date("w", $time); $firstDayofWeek = $time - (($weekday - $adjustment)*86400); $lastDayofWeek = $time + ((6 + $adjustment - $weekday) * 86400); } $day = time(); $arData[0]['records'] = $this->db->fetchAssoc("	SELECT 
														    COUNT(*) AS orders,
															SUM( `price_gesamt` ) AS total,
															HOUR( `cdate` ) AS hour, 
															'".date('d', $day)."' AS day, 
															'".date('m', $day)."' AS month, 
															'".date('Y', $day)."' AS year
													 	FROM 
													  		`".WPSG_TBL_ORDER."`
													 	WHERE 
													  		".$this->getSqlWhere('validOrder')." AND 
													  		`cdate`	>= '".date('Y-m-d 00:00:00', $firstDayofWeek)."' AND 
													  		`cdate` <= '".date('Y-m-d 23:59:59', $lastDayofWeek)."'
													 	GROUP BY 
													 		hour
													 	ORDER BY 
													 		hour ASC
													 ", "hour"); $this->setEmptyHours($day, $arData); $arData['template'] = 'all'; $arData[0]['day'] = date('d', $day); $arData[0]['month'] = date('m', $day); $arData[0]['year'] = date('Y', $day); $arData[0]['label'] = 'KW '.date('W', $firstDayofWeek)." ".date('Y', $firstDayofWeek); ksort($arData[0]['records']); if (isset($params['relatedpoint']) && is_numeric($params['relatedpoint'])) { $arRelatedData = $this->getWeek($params['relatedpoint']); $arData[] = $arRelatedData[0]; } return $arData; } public function getDay($point = 0, $params = array()) { if ($point == 0) { $day = time(); } else if ($point == -1) { $day = time() - 86400; } $arData[0]['records'] = $this->db->fetchAssoc("	SELECT 
														    COUNT(*) AS orders,
															SUM( `price_gesamt` ) AS total,
															HOUR( `cdate` ) AS hour, 
															'".date('d', $day)."' AS day, 
															'".date('m', $day)."' AS month, 
															'".date('Y', $day)."' AS year
													 	FROM 
													  		`".WPSG_TBL_ORDER."`
													 	WHERE 
													  		".$this->getSqlWhere('validOrder')." AND 
													  		YEAR( `cdate` ) = '".date('Y', $day)."' AND 
										  					MONTH ( `cdate` ) = '".date('m', $day)."' AND 
										  					DAY (`cdate`) = '".date('d', $day)."'
													 	GROUP BY 
													 		hour
													 	ORDER BY 
													 		hour ASC
													 ", "hour"); $this->setEmptyHours($day, $arData); $arData['template'] = 'all'; $arData[0]['day'] = date('d', $day); $arData[0]['month'] = date('m', $day); $arData[0]['year'] = date('Y', $day); $arData[0]['label'] = date('d.m.Y', $day); ksort($arData[0]['records']); if (isset($params['relatedpoint']) && is_numeric($params['relatedpoint'])) { $arRelatedData = $this->getDay($params['relatedpoint']); $arData[] = $arRelatedData[0]; } return $arData; } public function getCustomRange($oStart = 0, $oEnd = 0) { $start = wpsg_fieldarray_todate($_REQUEST['filter']['day'][0]); $end = wpsg_fieldarray_todate($_REQUEST['filter']['day'][1]); $day = time(); $arData[0]['records'] = $this->db->fetchAssoc(" SELECT 
														    COUNT(*) AS orders,
															SUM( `price_gesamt` ) AS total,
															HOUR( `cdate` ) AS hour, 
															'".date('d', $day)."' AS day, 
															'".date('m', $day)."' AS month, 
															'".date('Y', $day)."' AS year
													  	FROM 
													  		`".WPSG_TBL_ORDER."`
													  	WHERE 
													  		".$this->getSqlWhere('validOrder')." AND 
													  		`cdate`	>= '".date('Y-m-d 00:00:00', $start)."' AND 
													  		`cdate` <= '".date('Y-m-d 23:59:59', $end)."'
													  	GROUP BY 
													  		`hour`
													  	ORDER BY 
													 		hour ASC
													 	", "hour"); $this->setEmptyHours($day, $arData); $arData['template'] = 'all'; $arData[0]['day'] = date('d', $day); $arData[0]['month'] = date('m', $day); $arData[0]['year'] = date('Y', $day); $arData[0]['label'] = __('Statistikdaten', 'wpsg').': '.date('d.m.Y', $start).' - '.date('d.m.Y', $end); ksort($arData[0]['records']); return $arData; } }